#include "udp_packet.hpp"
#include <liblava/lava.hpp>

bool convert_udp_stereo_strategy(RemoteStrategy remote_strategey, UDPStereoStrategyId& udp_strategy)
{
    switch (remote_strategey)
    {
    case REMOTE_STRATEGY_DEBUG:
        udp_strategy = UDP_STEREO_STRATEGY_ID_DEBUG;
        break;
    case REMOTE_STRATEGY_NATIVE:
        udp_strategy = UDP_STEREO_STRATEGY_ID_NATIVE_STEREO;
        break;
    default:
        lava::log()->error("UDP-Transport: Unkown remote strategy!");
        return false;
    }

    return true;
}

bool convert_udp_controller(UDPControllerId udp_controller, Controller& controller)
{
    switch (udp_controller)
    {
    case UDP_CONTROLLER_ID_LEFT:
        controller = CONTROLLER_LEFT;
        break;
    case UDP_CONTROLLER_ID_RIGHT:
        controller = CONTROLLER_RIGHT;
        break;
    default:
        lava::log()->error("UDP-Transport: Unkown controller!");
        return false;
    }

    return true;
}

bool convert_udp_controller_state(UDPControllerState udp_controller_state, ControllerState& controller_state)
{
    switch (udp_controller_state)
    {
    case UDP_CONTROLLER_STATE_DETACHED:
        controller_state = CONTROLLER_STATE_DETACHED;
        break;
    case UDP_CONTROLLER_STATE_ATTACHED:
        controller_state = CONTROLLER_STATE_ATTACHED;
        break;
    default:
        lava::log()->error("UDP-Transport: Unkown controller state!");
        return false;
    }

    return true;
}

bool convert_udp_button(UDPButtonId udp_button, Button& button)
{
    switch (udp_button)
    {
    case UDP_BUTTON_ID_A:
        button = BUTTON_A;
        break;
    case UDP_BUTTON_ID_B:
        button = BUTTON_B;
        break;
    case UDP_BUTTON_ID_X:
        button = BUTTON_X;
        break;
    case UDP_BUTTON_ID_Y:
        button = BUTTON_Y;
        break;
    case UDP_BUTTON_ID_TRIGGER:
        button = BUTTON_TRIGGER;
        break;
    default:
        lava::log()->error("UDP-Transport: Unkown button!");
        return false;
    }

    return true;
}

bool convert_udp_button_state(UDPButtonState udp_button_state, ButtonState& button_state)
{
    switch (udp_button_state)
    {
    case UDP_BUTTON_STATE_PRESSED:
        button_state = BUTTON_STATE_PRESSED;
        break;
    case UDP_BUTTON_STATE_RELEASED:
        button_state = BUTTON_STATE_RELEASED;
        break;
    default:
        lava::log()->error("UDP-Transport: Unkown button state!");
        return false;
    }

    return true;
}